#include "sol_thrd.h"

static TickType_t disableAt;

void Solenoid_Trigger() {
	disableAt = xTaskGetTickCount() + pdMS_TO_TICKS(800);
	R_IOPORT_PinWrite(&g_ioport_ctrl, PIN_SOLENOID_NMOS, 1);
}

void sol_thrd_entry(void* pvParameters) {
	FSP_PARAMETER_NOT_USED(pvParameters);

	fsp_err_t fStatus;

	while (1) {

		bsp_io_level_t pinLevel;
		fStatus = R_IOPORT_PinRead(&g_ioport_ctrl, PIN_SOLENOID_NMOS, &pinLevel);
		if (fStatus) { __BKPT(0); }

		if (pinLevel == 1) {
			TickType_t now = xTaskGetTickCount();
			if (disableAt < now) {
				R_IOPORT_PinWrite(&g_ioport_ctrl, PIN_SOLENOID_NMOS, 0);
			}

		}

		vTaskDelay(1);
	}
}
